unit hiElem;

interface

uses Kol,Share,Debug,hitools_;

type
  THIElem = class(TDebug)
   private
   public
    _prop_Pack:string;

    _data_Pack:THI_Event;
    _event_onGroupExists:THI_Event;
    _event_onEnumElements:THI_Event;
    _event_onResult:THI_Event;
    _event_onEnumTabs:THI_Event;
    _event_onElementExists:THI_Event;
    _event_onTabByElem:THI_Event;

    procedure _work_doInstallEl(var _Data:TData; Index:word);
    procedure _work_doRemoveFromName(var _Data:TData; Index:word);
    procedure _work_doUnInstallEl(var _Data:TData; Index:word);
    procedure _work_doInstallPackage(var _Data:TData; Index:word);
    procedure _work_doTabByElem(var _Data:TData; Index:word);
    procedure _work_doMoveUpTab(var _Data:TData; Index:word);
    procedure _work_doMoveDownTab(var _Data:TData; Index:word);
    procedure _work_doMoveUpEl(var _Data:TData; Index:word);
    procedure _work_doMoveDownEl(var _Data:TData; Index:word);
  end;

implementation
type
  TEnumTabsProc = procedure (Name,Info:PChar; user:pointer); stdcall;

procedure InstallEl(fn:PChar); stdcall; external 'hitools.dll';
procedure RemoveFromName(Name,fdir:PChar); stdcall; external 'hitools.dll';
procedure UnInstallEl(fn:PChar); stdcall; external 'hitools.dll';
procedure InstallPackage(fn:pchar); stdcall; external 'hitools.dll';


procedure THIElem._work_doInstallEl;
begin
  InstallEl(PChar(toString(_Data)));
end;

procedure THIElem._work_doRemoveFromName;
begin
  RemoveFromName(PChar(toString(_Data)),PChar(ReadString(_Data, _Data_Pack, _prop_Pack)));
end;

procedure THIElem._work_doUnInstallEl;
begin
  UnInstallEl(PChar(toString(_Data)));
end;

procedure THIElem._work_doInstallPackage;
begin

end;

procedure THIElem._work_doTabByElem;
var p: string;
begin
  p:=TabByElem(toString(_Data),ReadString(_Data, _Data_Pack, _prop_Pack));
  _hi_CreateEvent(_Data,@_event_onTabByElem, p);
end;

procedure THIElem._work_doMoveUpTab;
begin
  MoveUpTab(ToString(_Data),ReadString(_Data, _Data_Pack, _prop_Pack));
end;

procedure THIElem._work_doMoveDownTab;
begin
  MoveDownTab(ToString(_Data),ReadString(_Data, _Data_Pack, _prop_Pack));
end;

procedure THIElem._work_doMoveUpEl;
begin
  MoveUpEl(toString(_Data),ReadString(_Data, _Data_Pack, _prop_Pack));
end;

procedure THIElem._work_doMoveDownEl;
begin
  MoveDownEl(ToString(_Data),ReadString(_Data, _Data_Pack, _prop_Pack));
end;

end.
