unit hitools_;
interface
uses kol, elmen_;


function TabByElem(name, fdir:String):String;
procedure MoveUpEl(ElID, fdir: String);
procedure MoveDownEl(ElID, fdir: String);
procedure MoveUpTab(name, fdir:String);  
procedure MoveDownTab(name, fdir:String);

implementation

// ##########################################################
// ##############    hitools.dll ##################
function TabByElem(name, fdir:String):String;
Var p: string;
begin
   p := GetStartDir + 'Elements\' + fdir + '\Elements.db';
   if not FileExists(p) then exit;
   OpenDB(PChar(p)); 
   result:=TabByEl(name);
   CloseDB;
end;

procedure MoveUpEl(ElID, fdir: String);
var p: string;
begin
   p := GetStartDir + 'Elements\' + fdir + '\Elements.db';
   if not FileExists(p) then exit;
   OpenDB(PChar(p));
   MoveEl(ElId, FindPrevEl(ElId));
   CloseDB;
end;

procedure MoveDownEl(ElID, fdir: String);
var p: string;
begin
   p := GetStartDir + 'Elements\' + fdir + '\Elements.db';
   if not FileExists(p) then exit;
   OpenDB(PChar(p));
   MoveEl(ElId, FindNextEl(ElId));
   CloseDB;
end;

procedure MoveUpTab(name, fdir:String);  
var p: string;
begin
   p := GetStartDir + 'Elements\' + fdir + '\Elements.db';
   if not FileExists(p) then exit;
   OpenDB(PChar(p));   p:=FindPrevTab(name);//msgok(p);
   MoveTab(name, p);
   CloseDB;
end;

procedure MoveDownTab(name, fdir:String);  
var p: string;
begin
   p := GetStartDir + 'Elements\' + fdir + '\Elements.db';
   if not FileExists(p) then exit;
   OpenDB(PChar(p));  p:=FindNextTab(name);//msgok(p);
   MoveTab(name, p);
   CloseDB;
end;

{
procedure ShiftEl(ElId, fdir:pchar; ShiftPos:Integer); {+1 down, -1 up 
Var p: string;
    El: TElRec;
begin
   p := GetStartDir + 'Elements\' + fdir + '\Elements.db';
   if not FileExists(p) then exit;
   OpenDB(PChar(p));  
   ElInfo(ElId, El);
   MoveEl(ElId, El.pos + ShiftPos);
   CloseDB;
end;

{procedure CopyF(const Dir,Ext,Target:string);
var SRec:TSearchRec;
  n:cardinal;
begin
    n := FindFirst(Dir + Ext,faAnyFile,SRec);
    while n = 0 do
     begin
       CopyFile(PChar(Dir + SRec.Name),PChar(Target + SREc.Name),true);
       n := FindNext(SRec);
     end;
    FindClose(SRec);
end;

procedure BackupEl(Name, fdir, bdir:PChar); stdcall;
var
    p,tabN:string;
begin
  p := GetStartDir + 'Elements\' + fdir;
  if not FileExists(p + '\Elements.db') then Exit;
  OpenDb(PChar(p));
  tabN:= TabByEl(Name);

  CloseDB;

  CopyF(p + '\icon\',Name+'.ico',bdir);
  CopyF(p + '\conf\',Name+'.ini',bdir);
  CopyF(p + '\code\hi',Name+'.pas',bdir);
  CopyF(p + '\code\hi',Name+'.h',bdir);
  //CopyF(p + '\code\','*.cpp',bdir);
end;

//##################################}

end.